;***********************************************************************
;     :         *
;                    -2109   PIC12F629.           *
;    File Version:    2       *
;                    .                                 *
;    Author:  ..                                                *
;***********************************************************************
	list      p=12F629             ;  ,   
	#include <p12F629.inc>         ;    
	__CONFIG   31FD
;******    ************************
gpio          EQU     H'5'        ;  \.
intcon        EQU     H'0B'       ;  .
otion_reg     EQU     H'1'        ;    .
pie1          EQU     H'8C'       ;       tmr1
pir1          EQU     H'0C'       ;       tmr1.
status        EQU     H'3'        ;   .
t1con         EQU     H'10'       ;    tmr1
trisio        EQU     H'5'        ;     \.
;*****   **********************************
ch_l          EQU     H'2E'       ;   
ch_h          EQU     H'2F'       ;   
tmr1l         EQU     H'0E'       ;    tmr1
tmr1h         EQU     H'0F'       ;    tmr1
usp           EQU     H'3F'       ;        .
;**********************************************************************
;***************  *****************************************************
	ORG     0x000                 ;   
  	goto    main                  ;    
        ORG     0x004                 ;   .
        
        btfsc  intcon,1               ;     .
        goto   dat                    ;      .
        btfsc  pir1,0                 ;      tmr1
        bcf    pir1,0                 ;      tmr1
        movlw  H'FF'
        movwf  tmr1l                  ;      tmr1
        movwf  tmr1h                  ;      tmr1
        movlw  b'00110000'            ;   b'00110001' .
        movwf  t1con                  ;   tmr1
        bsf    intcon,7               ;  .
           return
dat:    movlw  B'11010000'            ;   B'11010000'  .
        movwf  intcon                 ;      
        goto   start
;****************************************************************************************************
main:   clrwdt                        ;    
 
start:  bsf    status,5               ;-  5   3(status),..    1.
        movlw  b'11000000'            ;-  b'11000000' .
        movwf  otion_reg              ;-  otion_reg( ..    )   
        movlw  b'00000100'            ;-  b'00000100' .
        movwf  trisio                 ;-  trisio,(GP2 - , ).
        movlw  b'00000001'
        movwf  pie1                   ;      tmr1    
        bcf    status,5               ;-   0.
        movlw  b'00110001'            ;-  b'00110001' .
        movwf  t1con                  ;-  t1con (..  1=8,   )
        movlw  B'11010000'            
        movwf  intcon                 ;        tmr1.

nach:   bcf    gpio,5                 ;  ,  GP4=0 ().
        movfw  tmr1l                  ;       . 
        movwf  ch_l                   ;       .
        clrf   tmr1l                  ;    .
        movfw  tmr1h                  ;       .
        movwf  ch_h                   ;       .
        clrf   tmr1h                  ;    .
        clrf   usp                    ;         .
        movlw  H'1D'                  ;     
        subwf  ch_h,0                 ;    .
        btfsc  status,0               ;       488 /,   pusk1 
        goto   pusk1                  ;  .
        movlw  H'F'                   ;     
        subwf  ch_h,0                 ;    .
        btfsc  status,0               ;       976.5 /,   pusk
        goto   pusk                   ;     .
        goto   rab                    ;  .
;******  . ************************************************************************************
pusk1:  bsf    gpio,5                 ;  . GP4  1.(  ).
        clrf   ch_l                   ;    .
inc:    goto   $+1                    ;      
        clrwdt                        ;   (6,14 .).
        goto   $+1
        goto   $+1 
        goto   $+1
        goto   $+1
        goto   $+1
        goto   $+1                          
        goto   $+1
        goto   $+1                            
        goto   $+1
        incfsz ch_l,1                 ;      .  .
        goto   inc
        bcf    5,5                    ;  GP4  0.().
sub:    goto   $+1                    ;    .
        goto   $+1 
        goto   $+1
        decfsz ch_l,1                 ;     1,, 0
        goto   sub                    ;   sub
        bsf    gpio,5                 ;  GP4  1
        goto   k1                     ;   k1    .
;******    . **************************************************************************
pusk:   movlw  H'14'                  ;     
        subwf  ch_h,0                 ;     ch.
        btfsc  status,0               ;       732,5 /,   dec01 
        goto   dec01                  ;
        movlw  H'13'                  ;     
        subwf  ch_h,0                 ;     ch.
        btfsc  status,0               ;       771 /,   dec02 
        goto   dec02                  ;
        movlw  H'12'                  ;     
        subwf  ch_h,0                 ;     ch.
        btfsc  status,0               ;       814 /,   dec03 
        goto   dec03                  ;
        movlw  H'11'                  ;     
        subwf  ch_h,0                 ;     ch.
        btfsc  status,0               ;       861,4 /,   dec04 
        goto   dec04                  ;
        movlw  H'10'                  ;     
        subwf  ch_h,0                 ;     ch.
        btfsc  status,0               ;       915,5 /,   dec05
        goto   dec05                  ;
        movlw  H'F'                   ;     
        subwf  ch_h,0                 ;     ch.
        btfsc  status,0               ;       976,5 /,   dec06 
        goto   dec06                  ;
       
dec01:  movlw  H'3A'                  ;   .
        goto   sub00
dec02:  movlw  H'3B'                  ; 
        goto   sub00
dec03:  movlw  H'39'                  ;
        goto   sub00
dec04:  movlw  H'37'                  ; 
        goto   sub00
dec05:  movlw  H'35'                  ; 
        goto   sub00
dec06:  movlw  H'32'                  ; 

sub00:  subwf  ch_l,1                 ;     ,  .
        btfss  status,0               ;     3    1.
        decf   ch_h,1                 ;  1     ch.
        decf   ch_h,1                 ;    1     ch  
        decf   ch_h,1                 ;      .

sub01:  goto   $+1
        goto   $+1
        clrwdt                        ;   .
        decfsz ch_l,1                 ;     1,, 0 
        goto   sub01                  ;   sub01
        decfsz ch_h,1                 ;     1,, 0.
        goto   sub01                  
        bsf    gpio,5                 ;  GP4  1.(  ).

sub02:  goto   $+1                    ;      (6,14 .).
        goto   $+1
        clrwdt                        ;   .
        goto   $+1
        goto   $+1
        goto   $+1
        goto   $+1
        goto   $+1                             
        goto   $+1
        goto   $+1                            
        goto   $+1
        decfsz ch_l,1                 ;    1,, 0
        goto   sub02                  ;  sub02
        bcf    gpio,5                 ; GP4  0 ().
        goto   k1
;******  . ******************************************************
rab:    movlw  H'E'                   ;     
        subwf  ch_h,0                 ;    .
        btfsc  status,0               ;       1046 /,   dec1 
        goto   dec1                   ;
        movlw  H'D'                   ;     
        subwf  ch_h,0                 ;    .
        btfsc  status,0               ;       1127 /,   dec2 
        goto   dec2                   ;
        movlw  H'C'                   ;     
        subwf  ch_h,0                 ;    .
        btfsc  status,0               ;       1220.7 /,   dec3 
        goto   dec3                   ;
        movlw  H'B'                   ;     
        subwf  ch_h,0                 ;    .
        btfsc  status,0               ;       1331.6 /,   dec4 
        goto   dec4                   ;
        movlw  H'A'                   ;     
        subwf  ch_h,0                 ;    .
        btfsc  status,0               ;       1465 /,   dec5
        goto   dec5                   ;
        movlw  H'9'                   ;     
        subwf  ch_h,0                 ;    .
        btfsc  status,0               ;       1627.6 /,   dec6 
        goto   dec6                   ;
        movlw  H'8'                   ;     
        subwf  ch_h,0                 ;    .
        btfsc  status,0               ;       1831 /,   dec7 
        goto   dec7                   ;
        movlw  H'7'                   ;     
        subwf  ch_h,0                 ;    .
        btfsc  status,0               ;       2092.6 /,   dec8 
        goto   dec8                   ;
        movlw  H'6'                   ;     
        subwf  ch_h,0                 ;    .
        btfsc  status,0               ;       2441 /,   dec9 
        goto   dec9                   ;
        movlw  H'5'                   ;     
        subwf  ch_h,0                 ;    .
        btfsc  status,0               ;       2929.7 /,   dec10 
        goto   dec10                  ;
        movlw  H'4'                   ;     
        subwf  ch_h,0                 ;    .
        btfsc  status,0               ;       3662 /,   dec11 
        goto   dec11                  
        movlw  H'3'                   ;     
        subwf  ch_h,0                 ;    .
        btfsc  status,0               ;       4883 /,   dec12
        goto   dec12                  ;
        goto   dec13                  ;   4883 /.

dec1:   movlw  H'5E'                  ;      .
        goto   sub0
dec2:   movlw  H'72'                  ;      .
        goto   sub0
dec3:   movlw  H'86'                  ;      .
        goto   sub0
dec4:   movlw  H'95'                  ;      .
        goto   sub0
dec5:   movlw  H'A1'                  ;      .
        goto   sub0
dec6:   movlw  H'A6'                  ;      .
        goto   sub0
dec7:   movlw  H'A4'                  ;      .
        goto   sub0
dec8:   movlw  H'97'                  ;      .
        goto   sub0
dec9:   movlw  H'8D'                  ;      .
        goto   sub0
dec10:  movlw  H'85'                  ;      .
        goto   sub0
dec11:  movlw  H'80'                  ;      .
        goto   sub0
dec12:  movlw  H'79'                  ;      .
        goto   sub0
dec13   movlw  H'75'                  ;      .

sub0:   subwf  ch_l,1                 ;     ,  .
        btfss  status,0               ;     3    1.
        decf   ch_h,1                 ;  1    
        decf   ch_h,1                 ;  1    ,   
        movlw  H'80'                  ;    ,  .
        subwf  ch_l,1                 ;     ,  .
        btfss  status,0               ;     3    1.
        decfsz ch_h,1                 ;     1., 0.
        goto   sub1                   ;   sub1 
        goto   sub2                   ;   sub2

sub1:   goto   $+1
        goto   $+1
        clrwdt                        ;   .
        decfsz ch_l,1                 ;     1,, 0 
        goto   sub1                   ;   sub1
        decfsz ch_h,1                 ;     1,, 0.
        goto   sub1                  
        bsf    gpio,5                 ;  GP4  1.(  ).

sub2:   goto   $+1                    ;      (5,12 .).
        goto   $+1
        clrwdt                        ;   .
        goto   $+1
        goto   $+1
        goto   $+1                             
        goto   $+1
        goto   $+1                            
        goto   $+1
        decfsz ch_l,1                 ;    1,, 0
        goto   sub2                   ;  sub2
        bcf    gpio,5                 ; GP4  0 ().
                                   
k1:     goto   $+1
        clrwdt                        ;  .
        goto   $+1
        goto   $+1
        goto   $+1
        goto   $+1                             
        goto   $+1
        goto   $+1                            
        goto   $+1
        incfsz usp,1                  ; 1   1F,, 0.
        goto   k1                     ;  1
        bcf    gpio,5                 ; GP4  0.
        goto   k1                     ;  1

        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start

            end







































