;***********************************************************************
;     :     -2109  *
;                      PIC12F629.                    *
;    Author:  ..                                                *
;***********************************************************************
	list      p=12F629             ;  ,   
	#include <p12F629.inc>         ;    
	__CONFIG   31FD
;******    ************************
gpio          EQU     H'5'        ;  \.
intcon        EQU     H'0B'       ;  .
otion_reg     EQU     H'1'        ;    .
pie1          EQU     H'8C'       ;       tmr1
pir1          EQU     H'0C'       ;       tmr1.
status        EQU     H'3'        ;   .
t1con         EQU     H'10'       ;    tmr1
trisio        EQU     H'5'        ;     \.
;*****   **********************************
ch_l          EQU     H'2E'       ;   
ch_h          EQU     H'2F'       ;   
tmr1l         EQU     H'0E'       ;    tmr1
tmr1h         EQU     H'0F'       ;    tmr1
usp           EQU     H'3F'       ;        .
;**********************************************************************
;***************  *****************************************************
	ORG     0x000                 ;   
  	goto    main                  ;    
        ORG     0x004                 ;   .
        
        btfsc  intcon,1               ;     .
        goto   dat                    ;      .
        btfsc  pir1,0                 ;      tmr1
        bcf    pir1,0                 ;      tmr1
        movlw  H'FF'
        movwf  tmr1l                  ;      tmr1
        movwf  tmr1h                  ;      tmr1
        movlw  b'00110000'            ;   b'00110001' .
        movwf  t1con                  ;   tmr1
        bsf    intcon,7               ;  .
           return
dat:    movlw  B'11010000'            ;   B'11010000'  .
        movwf  intcon                 ;      
        goto   start
;****************************************************************************************************
main:   clrwdt                        ;    
 
start:  bsf    status,5               ;-  5   3(status),..    1.
        movlw  b'11000000'            ;-  b'11000000' .
        movwf  otion_reg              ;-  otion_reg( ..    )   
        movlw  b'00000100'            ;-  b'00000100' .
        movwf  trisio                 ;-  trisio,(GP2 - , ).
        movlw  b'00000001'
        movwf  pie1                   ;      tmr1    
        bcf    status,5               ;-   0.
        movlw  b'00110001'            ;-  b'00110001' .
        movwf  t1con                  ;-  t1con (..  1=8,   )
        movlw  B'11010000'            
        movwf  intcon                 ;        tmr1.

nach:   bcf    gpio,5                 ;  ,  GP4=0 ().
        movfw  tmr1l                  ;       . 
        movwf  ch_l                   ;       .
        clrf   tmr1l                  ;    .
        movfw  tmr1h                  ;       .
        movwf  ch_h                   ;       .
        clrf   tmr1h                  ;    .
        clrf   usp                    ;         .
        movlw  H'1D'                  ;     
        subwf  ch_h,0                 ;    .
        btfsc  status,0               ;       488 /,   pusk1 
        goto   pusk1                  ;  .
        movlw  H'F'                   ;     
        subwf  ch_h,0                 ;    .
        btfsc  status,0               ;       976.5 /,   pusk
        goto   pusk                   ;     .
        goto   rab                    ;  .
;******  . ************************************************************************************
pusk1:  bsf    gpio,5                 ;  . GP4  1.(  ).
        clrf   ch_l                   ;    .
inc:    goto   $+1                    ;      
        clrwdt                        ;   (6,14 .).
        goto   $+1
        goto   $+1 
        goto   $+1
        goto   $+1
        goto   $+1
        goto   $+1                          
        goto   $+1
        goto   $+1                            
        goto   $+1
        incfsz ch_l,1                 ;      .  .
        goto   inc
        bcf    gpio,5                 ;  GP4  0.().
sub:    goto   $+1                    ;    .
        goto   $+1 
        goto   $+1
        decfsz ch_l,1                 ;     1,, 0
        goto   sub                    ;   sub
        bsf    gpio,5                 ;  GP4  1
        goto   k1                     ;   k1    .
;******    . **************************************************************************
pusk:   movlw  H'EE'                  ;     sub0   .
        goto   sub0
;******  . ******************************************************
rab:    movlw  H'71'                  ;     sub0   .
sub0:   subwf  ch_l,1                 ;    ch  ,  .
        btfss  status,0               ;    3    1.
        decfsz ch_h,1                 ;    ch 1., 0.
        goto   sub1                   ;  sub1 
        goto   sub2                   ;  sub2
sub1:   goto   $+1
        goto   $+1
        clrwdt                        ;  .
        decfsz ch_l,1                 ;    ch 1,, 0 
        goto   sub1                   ;  sub1
        decfsz ch_h,1                 ;    ch 1,, 0.
        goto   sub1                  
        bsf    gpio,5                 ; GP5  1.(  ).

sub2:   goto   $+1
        goto   $+1
        clrwdt                        ;  .
        decfsz ch_l,1                 ;    ch 1,, 0
        goto   sub2                   ;  sub2
                 
k1:     goto   $+1
        clrwdt                        ;  .
        goto   $+1
        goto   $+1
        goto   $+1
        goto   $+1                             
        goto   $+1
        goto   $+1                            
        goto   $+1
        incfsz usp,1                  ; 1   1F,, 0.
        goto   k1                     ;  1
        bcf    gpio,5                 ; GP4  0.
        goto   k1                     ;  1

        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start
        goto   start

            end








































